(*
 *
 * Nombre: MiscDateTime.pas
 * Fecha: Lunes 22 de Junio del 2009
 * Autor: Ivn Jurez Nez
 * eMail: radix@redmater.com
 * Pagina: www.redmater.com
 *
 * Diversas funciones para obtener datos relacionados a la fecha y hora
 *
 * Este codigo se ofrece sin ninguna garantia y puede ser usado/modificado/redistribuido
 * con la unica condicion de incluir al autor en sus creditos.
 *)

unit MiscDateTime;

interface
  uses DateUtils, SysUtils, Windows;

FUNCTION GetTimeZone: integer;
FUNCTION GetUTCTime: TDateTime;

implementation

{ Obtiene la Zona Horaria usada por el Sistema }
FUNCTION GetTimeZone: integer;
var
  TimeZone: TTimeZoneInformation;
BEGIN
  GetTimeZoneInformation(TimeZone);
  Result := (TimeZone.Bias+TimeZone.DaylightBias+TimeZone.StandardBias) div -60;
END;
{ Obtiene el Tiempo local  GTM +0}
FUNCTION GetUTCTime:TDateTime;
BEGIN
   result := IncSecond(Now,3600*GetTimeZone);
END;

end.
