unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, ComCtrls, msxmldom, XMLDoc, StdCtrls, ExtCtrls,
  Vcl.Menus, AdvMenus, Vcl.Grids, AdvObj, BaseGrid, AdvGrid, FormSize, AdvMemo,
  Vcl.OleCtrls, SHDocVw, ShellApi;

type
  TForm1 = class(TForm)
    XMLDocument1: TXMLDocument;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    StatusBar1: TStatusBar;
    snippets: TAdvStringGrid;
    AdvMainMenu1: TAdvMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    FormSize1: TFormSize;
    procedure Button1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure snippetsClickCell(Sender: TObject; ARow, ACol: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
 DateTimeConversion;

{$R *.dfm}

//Reemplaza todas las Entidades HTML por su equivalente
//Funcion Original en LibXmlParser por Stefan Heymann
//www.destructor.de | stefan@destructor.de
PROCEDURE ReplaceCharacterEntities (VAR Str : STRING);
VAR
  Start  : INTEGER;
  PAmp   : PChar;
  PSemi  : PChar;
  PosAmp : INTEGER;
  Len    : INTEGER;
BEGIN
  IF Str = '' THEN EXIT;
  Start := 1;
  Str := StringReplace(Str,#$A,'',[rfReplaceAll, rfIgnoreCase]);
  Str := StringReplace(Str,#9,'',[rfReplaceAll, rfIgnoreCase]);
  REPEAT
    PAmp := StrPos (PChar (Str) + Start-1, '&#');
    IF PAmp = NIL THEN BREAK;
    PSemi := StrScan (PAmp+2, ';');
    IF PSemi = NIL THEN BREAK;
    PosAmp := PAmp - PChar (Str) + 1;
    Len    := PSemi-PAmp+1;
    IF CompareText (Str [PosAmp+2], 'x') = 0
      THEN Str [PosAmp] := CHR (StrToIntDef ('$'+Copy (Str, PosAmp+3, Len-4), 0))
      ELSE Str [PosAmp] := CHR (StrToIntDef (Copy (Str, PosAmp+2, Len-3), 32));
    Delete (Str, PosAmp+1, Len-1);
    Start := PosAmp + 1;
  UNTIL FALSE;
END;

//Extrae unicamente el Texto del HTML si es que lo tiene
FUNCTION TextFromHTML(s: string):string;
var
  IsText: Boolean;
  i: Integer;
begin
  result := '';
  IsText := true;

  for i := 1 to Length(s) do begin
    if s[i] = '<' then IsText := false;
    if IsText then result := result + s[i];
    if s[i] = '>' then IsText := true;
  end;

  Result := StringReplace(Result, '&quot;', '"',  [rfReplaceAll]);
  Result := StringReplace(Result, '&apos;', '''', [rfReplaceAll]);
  Result := StringReplace(Result, '&gt;',   '>',  [rfReplaceAll]);
  Result := StringReplace(Result, '&lt;',   '<',  [rfReplaceAll]);
  Result := StringReplace(Result, '&amp;',  '&',  [rfReplaceAll]);
  Result := StringReplace(Result, '&nbsp;',  ' ',  [rfReplaceAll]);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   StartItemNode : IXMLNode;
   NodoXML : IXMLNode;
   sAuthor, sTitle, sDate, sContent,sGUID: String;
   count : integer;
begin

  snippets.Clear;
  snippets.RowCount := 2;
  snippets.ColCount := 6;
  snippets.ColumnHeaders.Clear;
  snippets.ColumnHeaders.Add('Author');
  snippets.ColumnHeaders.Add('Title');
  snippets.ColumnHeaders.Add('Date');
  snippets.ColumnHeaders.Add('Content');
  snippets.ColumnHeaders.Add('GUID');
  count := 0;
  XMLDocument1.FileName := Edit1.Text;

  try
    XMLDocument1.Active := True;
    NodoXML := XMLDocument1.DocumentElement.ChildNodes.FindNode('channel');
    Form1.Caption := 'Simple RSS - '+NodoXML.ChildNodes['title'].Text;
    StartItemNode := XMLDocument1.DocumentElement.ChildNodes.First.ChildNodes.FindNode('item');
    NodoXML := StartItemNode;
    repeat
    sTitle := NodoXML.ChildNodes['title'].Text;
    sAuthor := NodoXML.ChildNodes['author'].Text;
    // <pubDate>Sat, 29 Mar 2014 07:33:16 +0000</pubDate>
    sDate := NodoXML.ChildNodes['pubDate'].Text;
    //sFecha := DateTimeToStr(RFC822toDateTime(sFecha));
    sContent := NodoXML.ChildNodes['content:encoded'].Text;
    sGUID := NodoXML.ChildNodes['guid'].Text;
    ReplaceCharacterEntities(sContent);

    inc(count);
    snippets.AddRow;
    snippets.Cells[0,count] := sAuthor;
    snippets.Cells[1,count] := sTitle;
    snippets.Cells[2,count] := sDate;
    snippets.Cells[3,count] := sContent;
    snippets.Cells[4,count] := sGUID;

    NodoXML := NodoXML.NextSibling;
    until NodoXML = nil;
  except
    on E: EDOMParseError do
    ShowMessage('DOMparser-Error');
    on E: Exception do
    ShowMessage('Error: '+E.Message);
  end;
end;
procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  snippets.Clear;
  snippets.RowCount := 2;
  snippets.ColumnHeaders.Clear;
  snippets.ColumnHeaders.Add('Title');
  snippets.ColumnHeaders.Add('Date');
  snippets.ColumnHeaders.Add('Content');
  snippets.ColumnHeaders.Add('GUID');
  Button1Click(Sender);
end;

procedure TForm1.snippetsClickCell(Sender: TObject; ARow, ACol: Integer);
var sl : TStringList;
begin
  if ARow > 0 then begin
    ShellExecute(Handle, 'open', PChar(snippets.Cells[4,ARow]),nil,nil, SW_SHOWNORMAL);
  end;
end;
end.
